searchData={"items":[{"type":"task","title":"mix nbpm.install","doc":"Insatlls `Nbpm` into `Mix.Release` scripts.","ref":"Mix.Tasks.Nbpm.Install.html"},{"type":"module","title":"Nbpm","doc":"Main module for Name-Based Port Mapper (Nbpm).\n\nThis module provides the core functionality for mapping node names to port\nnumbers in the context of Erlang distribution. It is designed to be used as\na custom EPMD (Erlang Port Mapper Daemon) module, which you can specify\nwith the `-epmd_module` option.","ref":"Nbpm.html"},{"type":"module","title":"Node name to port number mapping variants - Nbpm","doc":"- **Last up to 5 digits:** If the node name ends with digits, the last up to\n5 digits from the node name are considered as the port number. For example,\nfor a node name \"my_node12345\" the port number would be 12345.\n\n- **Special Prefixes:** If a node name starts with \"rem-\" or \"rpc-,\" it\nindicates that the OS should assign a random port. This is for\ncompatibility with `Mix.Release`.\n\n- **Hash-Based Port:** If none of the previous options match, the node name\nis hashed using the `:erlang.phash2` function, and the resulting hash is\nused as the port number. The port range is from 1024 to 65535.\n`:erlang.phash2` is a portable hash function that gives the same hash for\nthe same Erlang term regardless of machine architecture and ERTS version,\nthia ensures consistent name-to-port mappings across different machine\narchitectures and ERTS versions.\n\nTo determine to which port your node name translates, you can use the\n`name_to_port/1` function provided by this module.","ref":"Nbpm.html#module-node-name-to-port-number-mapping-variants"},{"type":"module","title":"Compatibility - Nbpm","doc":"Nbpm is compatible with Mix releases. When you execute\n`\"_build/prod/rel/your_app/bin/your_app remote\"`, it automatically\ngenerates node names in the format \"rem-$(rand)-name\" or\n\"rem-$(rand)-sname\". Similarly, when you execute\n`\"_build/prod/rel/your_app/bin/your_app rpc\"`, it generates\n\"rpc-$(rand)-name\" or \"rpc-$(rand)-sname\".\nNbpm responds to these names by offering port number 0, indicating that the\nOS should assign a random port.","ref":"Nbpm.html#module-compatibility"},{"type":"module","title":"References - Nbpm","doc":"* [How to Implement an Alternative Node Discovery for Erlang Distribution](https://www.erlang.org/doc/apps/erts/alt_disco)\n* `Mix.Release`","ref":"Nbpm.html#module-references"},{"type":"function","title":"Nbpm.address_please/3","doc":"","ref":"Nbpm.html#address_please/3"},{"type":"function","title":"Nbpm.available_ports_count/0","doc":"","ref":"Nbpm.html#available_ports_count/0"},{"type":"function","title":"Nbpm.listen_port_please/2","doc":"","ref":"Nbpm.html#listen_port_please/2"},{"type":"function","title":"Nbpm.name_to_port/1","doc":"Translates node name to port number.","ref":"Nbpm.html#name_to_port/1"},{"type":"function","title":"Nbpm.names/1","doc":"","ref":"Nbpm.html#names/1"},{"type":"function","title":"Nbpm.port_please/2","doc":"","ref":"Nbpm.html#port_please/2"},{"type":"function","title":"Nbpm.port_please/3","doc":"","ref":"Nbpm.html#port_please/3"},{"type":"function","title":"Nbpm.register_node/2","doc":"","ref":"Nbpm.html#register_node/2"},{"type":"function","title":"Nbpm.register_node/3","doc":"","ref":"Nbpm.html#register_node/3"},{"type":"function","title":"Nbpm.start_link/0","doc":"","ref":"Nbpm.html#start_link/0"},{"type":"extras","title":"Nbpm","doc":"# Nbpm\n\n> Name-Based Port Mapper\n\n[![CI](https://github.com/pertsevds/nbpm/actions/workflows/ci.yml/badge.svg)](https://github.com/pertsevds/nbpm/actions/workflows/ci.yml)\n[![Coverage Status](https://coveralls.io/repos/github/pertsevds/nbpm/badge.svg?branch=2-usage-docs)](https://coveralls.io/github/pertsevds/nbpm?branch=2-usage-docs)\n[![License](https://img.shields.io/hexpm/l/nbpm.svg)](https://hex.pm/packages/nbpm)\n[![Hex pm](https://img.shields.io/hexpm/v/nbpm.svg?style=flat)](https://hex.pm/packages/nbpm)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/nbpm)\n\n`Nbpm` is a lightweight Elixir module that provides a simplified implementation of the Erlang Port Mapper Daemon (EPMD) protocol. It enables basic functionality for mapping Erlang node names to network ports. This module is designed as a convenient alternative to a full EPMD implementation, making it easier to facilitate communication between Erlang nodes.","ref":"readme.html"},{"type":"extras","title":"Features - Nbpm","doc":"- `Mix.Release` compatibility.\n- Ability to specify port number in the node name.\n- Hash-Based Port from node name.","ref":"readme.html#features"},{"type":"extras","title":"Installation - Nbpm","doc":"To use Nbpm in your Elixir project, add it as a dependency in your `mix.exs` file:\n\n```elixir\ndef deps do\n[\n    {:nbpm, \"~> 0.2.0\"}\n]\nend\n```\n\nExecute `mix nbpm.install`\n\nThis will add `-start_epmd false -epmd_module Elixir.Nbpm` to `ELIXIR_ERL_OPTIONS` in files `rel/env.sh.eex` and `rel/env.bat.eex`","ref":"readme.html#installation"},{"type":"extras","title":"TODO - Nbpm","doc":"Installation to global: https://github.com/pertsevds/nbpm/issues/4","ref":"readme.html#todo"},{"type":"extras","title":"Documentation - Nbpm","doc":"https://hexdocs.pm/nbpm","ref":"readme.html#documentation"}],"content_type":"text/markdown"}